import logging_helper

logging = logging_helper.setup_logging()


class LogLines(object):

    _JOINER = u'\n' + 80 * u' '  # TODO: remove hardcoded 80 spaces

    def __init__(self,
                 name=None,
                 level=logging_helper.INFO,
                 log_lines=None):
        self.level = level
        self.name = name
        self._init_log_lines()
        if log_lines:
            self.append(log_lines)

    def _init_log_lines(self):
        self.log_lines = []
        if self.name:
            self.append(self.name)

    def append(self,
               line):
        # Being nice to bad users by handling lists
        # here as well as extend
        if isinstance(line, list):
            self.extend(line)
            return
        # Using extend on the split string in
        # is contains newlines.
        self.log_lines.extend(line.split(u'\n'))

    def extend(self,
               lines):
        for line in lines:
            # Not using extend in case there are
            # new lines in individual strings.
            self.append(line)

    def push(self):
        if any(self.log_lines):
            logging.log(level=self.level,
                        msg=self._JOINER.join(self.log_lines))
            self._init_log_lines()

    def __del__(self):
        self.push()
